{******************************************************************************}
{*                                                                            *}
{* Programm: Neuro chip test version                                          *}
{* Net type: Back propagation                                                 *}
{* Normalization: Linear                                                      *}
{* Author: Miktyuk Sergey, Frolov Valentin aka 'BonifacE'                     *}
{* tel: +7-0912-25-17-50                                                      *}
{* Email: mail@silentium.ru                                                   *}
{* Copyright (c) Silentium 2004                                               *}
{******************************************************************************}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Grids, StdCtrls, Buttons, DB, DBTables, DBGrids,
  ToolWin, ExtCtrls, DBCtrls, CheckLst, NeuralNetworkBP, ImgList, TeEngine,
  TeeFunci, Series, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    DataSource1: TDataSource;
    Table1: TTable;
    NeuralNetworkBP1: TNeuralNetworkBP;
    ImageList1: TImageList;
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ToolBar1: TToolBar;
    DBNavigator1: TDBNavigator;
    BitBtn2: TBitBtn;
    DBGrid1: TDBGrid;
    ToolBar2: TToolBar;
    ToolButton3: TToolButton;
    btnNext1: TBitBtn;
    TabSheet2: TTabSheet;
    ToolBar3: TToolBar;
    btnBack2: TBitBtn;
    ToolButton4: TToolButton;
    btnNext2: TBitBtn;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    sgFP: TStringGrid;
    TabSheet3: TTabSheet;
    ToolBar4: TToolBar;
    btnBack3: TBitBtn;
    ToolButton5: TToolButton;
    btnNext3: TBitBtn;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ud1: TUpDown;
    StringGrid1: TStringGrid;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    edA: TEdit;
    edMiu: TEdit;
    edTS: TEdit;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    edSC: TEdit;
    UpDown1: TUpDown;
    TabSheet4: TTabSheet;
    ToolBar5: TToolBar;
    btnBack4: TBitBtn;
    ToolButton6: TToolButton;
    btnNext4: TBitBtn;
    TabSheet5: TTabSheet;
    ToolBar6: TToolBar;
    btnBack5: TBitBtn;
    StringGrid2: TStringGrid;
    ToolBar7: TToolBar;
    Edit4: TEdit;
    UpDown2: TUpDown;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    edTL: TEdit;
    UpDown3: TUpDown;
    Label9: TLabel;
    edEC: TEdit;
    UpDown4: TUpDown;
    Label11: TLabel;
    OpenDialog2: TOpenDialog;
    NeuralNetworkBP2: TNeuralNetworkBP;
    Chart1: TChart;
    Series1: TLineSeries;
    TeeFunction1: TAddTeeFunction;
    ToolBar8: TToolBar;
    BitBtn1: TBitBtn;
    BitBtn5: TBitBtn;
    btnShMat: TBitBtn;
    btnStop: TBitBtn;
    ToolButton1: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure btnNext1Click(Sender: TObject);
    procedure btnBack2Click(Sender: TObject);
    procedure btnNext2Click(Sender: TObject);
    procedure btnNext3Click(Sender: TObject);
    procedure btnNext4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ud1Click(Sender: TObject; Button: TUDBtnType);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure BitBtn1Click(Sender: TObject);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure FormDestroy(Sender: TObject);
    procedure sgFPSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure btnBack3Click(Sender: TObject);
    procedure btnBack4Click(Sender: TObject);
    procedure btnBack5Click(Sender: TObject);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
    procedure BitBtn5Click(Sender: TObject);
    procedure btnShMatClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NCM: array of integer;
  LCM: array of integer;
  InNC,OutNC,LC,sc: integer;
  alpha,ts,miu,tl: double;
  OpenTableChk,StopTeach: boolean;
  RS: integer;
  A,B: integer;
implementation

uses Info;
{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 PageControl1.Pages[0].Caption:='';
 PageControl1.Pages[1].Caption:='';
 PageControl1.Pages[2].Caption:='';
 PageControl1.Pages[3].Caption:='';
 PageControl1.Pages[4].Caption:='';
 PageControl1.ActivePage:=TabSheet1;
 StringGrid1.ColWidths[0]:=40;
 StringGrid1.Cells[0,0]:='layer ';
 StringGrid1.ColWidths[1]:=78;
 StringGrid1.Cells[1,0]:='Neurons count';
 StringGrid1.Cells[0,1]:='1';
 StringGrid1.Cells[1,1]:='8';
 StringGrid1.Cells[0,2]:='2';
 StringGrid1.Cells[1,2]:='8';
 sgFP.ColWidths[0]:=99;
 sgFP.Cells[0,0]:='Field name';
 sgFP.ColWidths[1]:=80;
 sgFP.Cells[1,0]:='Mode';
 alpha:=1;
 ts:=0.05;
 miu:=0.9;
 Form1.Caption:='Step 1: Load table to work';
 A:=5; B:=5;
 EdTL.Text:=inttostr(A)+'E-'+inttostr(B);
 Tl:=strtofloat(edTL.Text);
 UpDown3.Position:=5;
 StopTeach:=false;
end;

procedure TForm1.btnNext1Click(Sender: TObject);
var
 i:integer;
 CanSelect: boolean;
begin
 PageControl1.SelectNextPage(true,false);
 SetLength(NCM,Table1.FieldCount);
 sgFP.RowCount:=Table1.FieldCount+1;
 for i:=1 to Table1.FieldCount do
  begin
   if i=Table1.FieldCount
    then
     begin
      sgFP.Cells[0,i]:=Table1.Fields[i-1].FieldName;
      sgFP.Cells[1,i]:='Output';
      NCM[i-1]:=2;
     end
    else
     begin
      sgFP.Cells[0,i]:=Table1.Fields[i-1].FieldName;
      sgFP.Cells[1,i]:='Input';
      NCM[i-1]:=1;
     end;
  end;
 CanSelect:=true;
 sgFP.onSelectCell(Sender,0,1,CanSelect);
 Form1.Caption:='Step 2: Choose fields settings';
end;

procedure TForm1.btnBack2Click(Sender: TObject);
begin
 PageControl1.SelectNextPage(false,false);
 Form1.Caption:='Step 1: Load table to work';
end;

procedure TForm1.btnNext2Click(Sender: TObject);
var
 i: integer;
begin
 InNC:=0;
 OutNC:=0;
 for i:=0 to Table1.FieldCount-1 do
  case NCM[i] of
   1: InNC:=InNC+1;
   2: OutNC:=OutNC+1;
  end;
 if InNC=0
  then
   MessageDlg('No one input field!',mtError,[mbOK],0);
 if OutNC=0
  then
   MessageDlg('No one output field!',mtError,[mbOK],0);
 if (InNC>0) and (OutNC>0)
  then
   begin
    Edit1.Text:=inttostr(InNC);
    Edit3.Text:=IntToStr(OutNC);
    PageControl1.SelectNextPage(true,false);
    Form1.Caption:='Step 3: Tune net settings';
   end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var
 i:integer;
begin
 if CheckBox1.State=cbChecked then
  for i:=1 to Table1.FieldCount do
   if RS=i
    then
     begin
      NCM[i-1]:=1;
      CheckBox2.State:=cbUnchecked;
      CheckBox3.State:=cbUnchecked;
      sgFP.Cells[1,i]:='Input';
     end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
var
 i:integer;
begin
 if CheckBox2.State=cbChecked then
  for i:=1 to Table1.FieldCount do
   if RS=i
    then
     begin
      NCM[i-1]:=2;
      CheckBox1.State:=cbUnchecked;
      CheckBox3.State:=cbUnchecked;
      sgFP.Cells[1,i]:='Output';
     end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
var
 i:integer;
begin
 if CheckBox3.State=cbChecked then
  for i:=1 to Table1.FieldCount do
   if RS=i
    then
     begin
      NCM[i-1]:=3;
      CheckBox2.State:=cbUnchecked;
      CheckBox1.State:=cbUnchecked;
      sgFP.Cells[1,i]:='Dont use';
     end;
end;

procedure TForm1.ud1Click(Sender: TObject; Button: TUDBtnType);
begin
 StringGrid1.RowCount:=strtoint(Edit2.Text)+1;
 StringGrid1.Cells[0,strtoint(Edit2.Text)]:=Edit2.Text;
 StringGrid1.Cells[1,strtoint(Edit2.Text)]:='8';
end;

procedure TForm1.btnNext3Click(Sender: TObject);
var
 i: integer;
begin
 TL:=strtofloat(EdTL.text);
 LC:=StringGrid1.RowCount-1;
 SetLength(LCM,LC+2);
 LCM[0]:=InNC;
 LCM[LC+1]:=OutNC;
 for i:=1 to LC do
  LCM[i]:=strtoint(StringGrid1.Cells[1,i]);
 //  
 NeuralNetworkBP1.CountHiddenLayers:=LC;
 // ( .)
 NeuralNetworkBP1.Configurate(LCM);
 NeuralNetworkBP1.Alpha:=Alpha;
 NeuralNetworkBP1.Miu:=Miu;
 NeuralNetworkBP1.TeachSpeed:=ts;
 NeuralNetworkBP1.Tolerance:=strtofloat(edTL.Text);
 NeuralNetworkBP1.MaxEpochCount:=StrToInt(edEC.Text);
 NeuralNetworkBP1.MaxShockCount:=sc;
 PageControl1.SelectNextPage(true,false);
 Form1.Caption:='Step 4: Teach net';
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 Alpha:=TrackBar1.Position/100;
 edA.Text:=floattostr(Alpha);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
 Miu:=TrackBar2.Position/100;
 edMiu.Text:=floattostr(Miu);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
 TS:=TrackBar3.Position/100;
 edTS.Text:=floattostr(TS);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 sc:=UpDown1.Position;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
 chk: boolean;
 i,j,k,sm:integer;
 tm,vtm: array of array of double;
 ch,inTm,outTm:integer;
 tmp: double;
 rt: boolean;
 h: double;
begin
 Chart1.Series[0].Clear;
 btnStop.Enabled:=true;
 btnShMat.Enabled:=false;
 BitBtn5.Enabled:=false;
 btnBack4.Enabled:=false;
 StopTeach:=false;
 btnNext4.Enabled:=false;
 BitBtn1.Enabled:=false;
 Application.ProcessMessages;
 SetLength(tm,Table1.RecordCount);
 SetLength(vtm,Table1.RecordCount);
 for i:=0 to Table1.RecordCount-1 do
  begin
   SetLength(tm[i],InNC+OutNC);
   SetLength(vtm[i],InNC+OutNC+1);
  end;
 inTm:=0;
 outTm:=0;
 for j:=0 to Table1.FieldCount-1 do
  begin
    ch:=NCM[j];
    case ch of
     1: begin
         Table1.First;
         for k:=0 to Table1.RecordCount-1 do
          begin
           tm[k,intm]:=Table1.Fields.Fields[j].AsFloat;
           Table1.Next;
          end;
          inTm:=inTm+1;
        end;
     2: begin
         Table1.First;
         for k:=0 to Table1.RecordCount-1 do
          begin
           tm[k,inNC+outTM]:=Table1.Fields.Fields[j].AsFloat;
           Table1.Next;
          end;
          outTM:=outTM+1;
        end;
    end;
  end;
 NeuralNetworkBP1.SetTeachMatrix(Table1.RecordCount);
 //    
 for i:=0 to Table1.RecordCount-1 do
  for j:=0 to InNC+outNC-1 do
   NeuralNetworkBP1.TeachMatrix[i,j]:=tm[i,j];
  // 
 sm:=0;
 repeat
  chk:=NeuralNetworkBP1.Learn;
  for i:=0 to Table1.RecordCount-1 do
   for j:=0 to InNC+OutNC do
    vtm[i,j]:=NeuralNetworkBP1.VTMatrix[i,j];
  Application.ProcessMessages;
  Chart1.Series[0].AddXY(sm,NeuralNetworkBP1.Epsilon);
  sm:=sm+1;
 Until (StopTeach=true) or (NeuralNetworkBP1.Tolerance>NeuralNetworkBP1.Epsilon) or (chk=false);

 btnNext4.Enabled:=true;
 btnShMat.Enabled:=true;
 //InfForm.Show;
 InfForm.StringGrid1.ColCount:=InNC+OutNc+1;
 InfForm.StringGrid1.RowCount:=Table1.RecordCount+1;
 for i:=0 to Table1.FieldCount-1 do
  InfForm.StringGrid1.Cells[i,0]:=Table1.Fields[i].FieldName;
 InfForm.StringGrid1.Cells[InNC+OutNc,0]:='Sqr.Eps';

 for i:=1 to Table1.RecordCount do
  for j:=0 to Table1.FieldCount do
   InfForm.StringGrid1.Cells[j,i]:=floattostr(vtm[i-1,j]);
 btnShMat.Enabled:=true;
 BitBtn5.Enabled:=true;
 btnBack4.Enabled:=true;
 BitBtn1.Enabled:=true;
end;

procedure TForm1.btnNext4Click(Sender: TObject);
var
 i:integer;
begin
 StringGrid2.ColCount:=InNC+OutNc;
 StringGrid2.RowCount:=2;
 NeuralNetworkBP1.SetCalcMatrix(1);
 for i:=0 to Table1.FieldCount-1 do
  StringGrid2.Cells[i,0]:=Table1.Fields[i].FieldName;
 for i:=0 to Table1.FieldCount-1 do
  StringGrid2.Cells[i,1]:='0';
 PageControl1.SelectNextPage(true,false);
 Form1.Caption:='Step 5: Calculate with net';
end;

procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
var
 i: integer;
begin
 if (StringGrid2.RowCount<strtoint(Edit4.Text)+1)
  then
   begin
    StringGrid2.RowCount:=strtoint(Edit4.Text)+1;
    NeuralNetworkBP1.SetCalcMatrix(strtoint(Edit4.Text));
    for i:=0 to Table1.FieldCount-1 do
     StringGrid2.Cells[i,strtoint(Edit4.Text)]:='0';
   end
  else
   begin
    StringGrid2.RowCount:=strtoint(Edit4.Text)+1;
    NeuralNetworkBP1.SetCalcMatrix(strtoint(Edit4.Text));
   end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 NeuralNetworkBP1.Free;
end;

procedure TForm1.sgFPSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
 i:integer;
begin
 for i:=0 to Table1.FieldCount-1 do
  if ARow-1=i
   then
    begin
     case NCM[i] of
      1: begin
          RS:=ARow;
          CheckBox1.State:=cbChecked;
          CheckBox2.State:=cbUnchecked;
          CheckBox3.State:=cbUnchecked;
         end;
      2: begin
          RS:=ARow;
          CheckBox1.State:=cbUnchecked;
          CheckBox2.State:=cbChecked;
          CheckBox3.State:=cbUnchecked;
         end;
      3: begin
          RS:=ARow;
          CheckBox1.State:=cbUnchecked;
          CheckBox2.State:=cbUnchecked;
          CheckBox3.State:=cbChecked;
         end;
     end;
    end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 if OpenTableChk=false
  then
   begin
    if OpenDialog1.Execute
     then
      begin
       try
        Table1.Active:=false;
        Table1.TableName:=OpenDialog1.FileName;
        Table1.Active:=true;
        btnNext1.Enabled:=true;
        OpenTableChk:=true;
        btnNext4.Enabled:=false;
       except
        ShowMessage('Uncorrect file');
       end;
      end;
   end
  else
   begin
    if MessageDlg('Do you realy want to load new table?',mtConfirmation,[mbNO,mbYES],0)=mrYES
     then
      begin
       btnNext1.Enabled:=false;
       OpenTableChk:=false;
       BitBtn2Click(Sender);
      end;
   end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 if SaveDialog1.Execute
  then
   NeuralNetworkBP1.SaveNetParam(SaveDialog1.FileName);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
 i,j: integer;
 cm: array of array of double;
 rv: double;
begin
 rv:=1;
 for i:=1 to B do
  rv:=rv*10;
 SetLength(cm,strtoint(Edit4.Text));
 for i:=0 to strtoint(Edit4.Text)-1 do
  SetLength(cm[i],InNC+OutNC);

 for i:=0 to strtoint(Edit4.Text)-1 do
  for j:=0 to InNC-1 do
   cm[i,j]:=strtofloat(StringGrid2.Cells[j,i+1]);

 for i:=0 to strtoint(Edit4.Text)-1 do
  for j:=0 to InNC-1 do
   NeuralNetworkBP1.InMatrix[i,j]:=cm[i,j];

 NeuralNetworkBP1.Calculate;
 for i:=0 to strtoint(Edit4.Text)-1 do
  for j:=InNC to OutNC+InNC-1 do
   cm[i,j]:=NeuralNetworkBP1.OutMatrix[i,j-InNC];

 for i:=0 to strtoint(Edit4.Text)-1 do
  for j:=0 to InNC+OutNC-1 do
   StringGrid2.Cells[j,i+1]:=floattostr(Round(cm[i,j]*rv) / rv );
end;

procedure TForm1.btnBack3Click(Sender: TObject);
begin
 PageControl1.SelectNextPage(false,false);
 Form1.Caption:='Step 2: Choose fields settings';
end;

procedure TForm1.btnBack4Click(Sender: TObject);
begin
 PageControl1.SelectNextPage(false,false);
 Form1.Caption:='Step 3: Tune net settings';
end;

procedure TForm1.btnBack5Click(Sender: TObject);
begin
 PageControl1.SelectNextPage(false,false);
 Form1.Caption:='Step 4: Teach net';
 Edit4.Text:='1';
 StringGrid2.RowCount:=strtoint(Edit4.Text)+1;
 NeuralNetworkBP1.SetCalcMatrix(strtoint(Edit4.Text));
end;

procedure TForm1.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
 A:=UpDown3.Position;
 case A of
  10: begin
       A:=1;
       UpDown3.Position:=1;
       B:=B-1;
       if B=0
        then
         begin
          A:=9; B:=1; UpDown3.Position:=9;
         end;
      end;
  0:  begin
       A:=9;
       UpDown3.Position:=9;
       B:=B+1;

      end;
 end;
 EdTL.Text:=inttostr(A)+'E-'+inttostr(B);
 Tl:=strtofloat(edTL.Text);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
 if OpenDialog2.Execute
  then
   begin
    NeuralNetworkBP2.LoadNetParam(OpenDialog2.FileName);
    if (NeuralNetworkBP2.OutNC=OutNC) and (NeuralNetworkBP2.InNC=InNC)
     then
      begin
       NeuralNetworkBP1.LoadNetParam(OpenDialog2.FileName);
       btnNext4.Enabled:=true;
       btnShMat.Enabled:=false;
      end
     else
      MessageDlg('Uncorrect neuro ini file for choosen table'+#10#13+'or uncorrect fields parametrs!',mtError,[mbOK],0);
   end;
end;

procedure TForm1.btnShMatClick(Sender: TObject);
begin
 InfForm.Show;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
 StopTeach:=true;
 btnStop.Enabled:=false;
end;

end.
